Index: applications/editors/josm/plugins/surveyor/build.xml
===================================================================
--- applications/editors/josm/plugins/surveyor/build.xml	(revision 4522)
+++ applications/editors/josm/plugins/surveyor/build.xml	(revision 5147)
@@ -1,34 +1,34 @@
 <project name="surveyor" default="dist" basedir=".">
 
-	 <!-- compilation properties -->
-	  <property name="josm.build.dir" value="../../core"/>
-	  <property name="josm.home.dir" value="${user.home}/.josm"/>
-	  <property name="plugin.build.dir" value="bin"/>
-	  <property name="plugin.name" value="${ant.project.name}"/>
-	  <property name="plugin.jar" value="${plugin.name}.jar"/>
-    <property name="livegpsplugin.jar" value="${josm.home.dir}/plugins/livegps.jar"/>
-	  
-	  <!-- plugin meta data (enter new version number if anything changed!) -->
-	  <property name="plugin.version" value="1.3.3"/>
-	  <property name="plugin.description" value="Allow adding markers/nodes on current gps positions (V${plugin.version})."/>
-	  <property name="plugin.stage" value="60"/>
-    <property name="plugin.class" value="at.dallermassl.josm.plugin.surveyor.SurveyorPlugin"/>
-	  
-	  <!-- update site meta data -->
-	  <property name="plugin.site.file" value="josm-site.xml"/>
-	  <property name="plugin.site.description" value="Josm's Surveyor Update Site"/>
-	  <property name="plugin.site.url" value="http://www.tegmento.org/~cdaller/josm/surveyor/"/>
-	  <property name="plugin.site.upload.target" value="cdaller@www.tegmento.org:public_html/josm/surveyor/"/>
-	  
+  <!-- compilation properties -->
+  <property name="josm.build.dir" value="../../core"/>
+  <property name="josm.home.dir" value="${user.home}/.josm"/>
+  <property name="plugin.build.dir" value="bin"/>
+  <property name="plugin.name" value="${ant.project.name}"/>
+  <property name="plugin.jar" value="${plugin.name}.jar"/>
+  <property name="livegpsplugin.jar" value="../livegps/livegps.jar"/>
+  
+  <!-- plugin meta data (enter new version number if anything changed!) -->
+  <property name="plugin.version" value="1.3.3"/>
+  <property name="plugin.description" value="Allow adding markers/nodes on current gps positions (V${plugin.version})."/>
+  <property name="plugin.stage" value="60"/>
+  <property name="plugin.class" value="at.dallermassl.josm.plugin.surveyor.SurveyorPlugin"/>
+  
+  <!-- update site meta data -->
+  <property name="plugin.site.file" value="josm-site.xml"/>
+  <property name="plugin.site.description" value="Josm's Surveyor Update Site"/>
+  <property name="plugin.site.url" value="http://www.tegmento.org/~cdaller/josm/surveyor/"/>
+  <property name="plugin.site.upload.target" value="cdaller@www.tegmento.org:public_html/josm/surveyor/"/>
+  
 
-	<target name="dist" depends="compile,site">
-		<!-- images -->
-		<copy todir="${plugin.build.dir}/">
-			<fileset dir="resources">
-				<include name="*.xml"/>
-				<include name="audio/*"/>
-		  </fileset>
-		</copy>
-		
+  <target name="dist" depends="compile,site">
+    <!-- images -->
+    <copy todir="${plugin.build.dir}/">
+      <fileset dir="resources">
+	<include name="*.xml"/>
+	<include name="audio/*"/>
+      </fileset>
+    </copy>
+    
     <!-- create jar file -->
     <jar destfile="${plugin.jar}" basedir="${plugin.build.dir}">
@@ -41,18 +41,18 @@
       </manifest>
     </jar>
-	</target>
+  </target>
 
-	<target name="compile" depends="init">
-		<mkdir dir="${plugin.build.dir}"/>
-		<javac srcdir="src" destdir="${plugin.build.dir}" debug="true" source="1.5" target="1.5">
-			<classpath>
-				<pathelement path="${josm.build.dir}/build"/>
-	      <fileset dir="${josm.build.dir}/lib">
-	        <include name="**/*.jar"/>
-	      </fileset>
+  <target name="compile" depends="init">
+    <mkdir dir="${plugin.build.dir}"/>
+    <javac srcdir="src" destdir="${plugin.build.dir}" debug="true" source="1.5" target="1.5">
+      <classpath>
+	<pathelement path="${josm.build.dir}/build"/>
+	<fileset dir="${josm.build.dir}/lib">
+	  <include name="**/*.jar"/>
+	</fileset>
         <pathelement location="${livegpsplugin.jar}"/>
-			</classpath>
-	  </javac>
-	</target>
+      </classpath>
+    </javac>
+  </target>
 
   <target name="install" depends="dist">
@@ -61,6 +61,6 @@
 
   <target name="init">
-     <echo>java version: ${java.version}</echo>
-   </target>
+    <echo>java version: ${java.version}</echo>
+  </target>
 
   <target name="clean">
@@ -75,49 +75,49 @@
     <echo file="${plugin.site.file}">&lt;!-- plugins available on this site -->
   &lt;plugins>
-    &lt;plugin id="${ant.project.name}" version="${plugin.version}">
-      &lt;name>${ant.project.name}&lt;/name>
-      &lt;description>${plugin.description}&lt;/description>
-      &lt;resource>${plugin.site.url}${plugin.jar}&lt;/resource>
-    &lt;/plugin>
+  &lt;plugin id="${ant.project.name}" version="${plugin.version}">
+  &lt;name>${ant.project.name}&lt;/name>
+  &lt;description>${plugin.description}&lt;/description>
+  &lt;resource>${plugin.site.url}${plugin.jar}&lt;/resource>
+  &lt;/plugin>
   &lt;/plugins>
-    </echo>
-  </target>
+</echo>
+</target>
 
-  <!-- write site description for the given plugin (not implemented in JOSM as full version yet!) -->
-  <target name="site-full-donotuse">
-    <echo message="creating site description in ${plugin.site.file}"/>
-    <echo file="${plugin.site.file}">&lt;?xml version="1.0"?>
-&lt;site version="1.0">
-  &lt;!-- meta data of site -->
-  &lt;site-info>
-    &lt;site-name>${plugin.site.description}&lt;/site-name>
-    &lt;site-url>${plugin.site.url}&lt;/site-url>
-  &lt;/site-info>
+<!-- write site description for the given plugin (not implemented in JOSM as full version yet!) -->
+<target name="site-full-donotuse">
+  <echo message="creating site description in ${plugin.site.file}"/>
+  <echo file="${plugin.site.file}">&lt;?xml version="1.0"?>
+    &lt;site version="1.0">
+    &lt;!-- meta data of site -->
+&lt;site-info>
+&lt;site-name>${plugin.site.description}&lt;/site-name>
+&lt;site-url>${plugin.site.url}&lt;/site-url>
+&lt;/site-info>
 
-  &lt;!-- plugins available on this site -->
-  &lt;plugins>
-    &lt;plugin id="${ant.project.name}" version="${plugin.version}">
-      &lt;name>${ant.project.name}&lt;/name>
-      &lt;description>${plugin.description}&lt;/description>
-      &lt;resources>
-        &lt;resource src="${plugin.site.url}${plugin.jar}"
-                  target="${josm.home.dir}/plugins/${plugin.jar}"/>
-      &lt;/resources>
-    &lt;/plugin>
-  &lt;/plugins>
+&lt;!-- plugins available on this site -->
+&lt;plugins>
+&lt;plugin id="${ant.project.name}" version="${plugin.version}">
+&lt;name>${ant.project.name}&lt;/name>
+&lt;description>${plugin.description}&lt;/description>
+&lt;resources>
+&lt;resource src="${plugin.site.url}${plugin.jar}"
+target="${josm.home.dir}/plugins/${plugin.jar}"/>
+&lt;/resources>
+&lt;/plugin>
+&lt;/plugins>
 &lt;/site>
-    </echo>
-  </target>
+</echo>
+</target>
 
 
-  <!-- upload the site description and the jar file via ssh -->
-  <target name="upload" depends="dist,site">
-    <echo message="uploading jar and site description to ${plugin.site.upload.target}"/>
-    <exec executable="scp">
-      <arg value="${plugin.jar}"/>
-      <arg value="${plugin.site.file}"/>
-      <arg value="${plugin.site.upload.target}"/>
-    </exec>
-  </target>
+<!-- upload the site description and the jar file via ssh -->
+<target name="upload" depends="dist,site">
+  <echo message="uploading jar and site description to ${plugin.site.upload.target}"/>
+  <exec executable="scp">
+    <arg value="${plugin.jar}"/>
+    <arg value="${plugin.site.file}"/>
+    <arg value="${plugin.site.upload.target}"/>
+  </exec>
+</target>
 
 </project>